aboutsummaryrefslogtreecommitdiffstats
path: root/yardstick/benchmark/scenarios/availability/attacker
diff options
context:
space:
mode:
authorwym_libra <yimin.wang@huawei.com>2015-12-07 16:02:18 +0800
committerwym_libra <yimin.wang@huawei.com>2015-12-18 10:09:08 +0800
commit53a96f499680587dc2f6172a964af35f9ce1c74b (patch)
tree0e6326ee1bd7d8e99c0c8ddc3cd0a9b50bb1dc6b /yardstick/benchmark/scenarios/availability/attacker
parent05c1840c9c4dda154c9c5d00ff3cd23ba202330b (diff)
Rewrite the HA test case (1)
refactor the attacker implement. 1) BaseAttacker is added 2) a simple attacker named "kill-process" inherit the BaseAttacker 3) serviceha.py selects an attacker through the BaseAttacker by attacker name JIRA: YARDSTICK-149 Change-Id: Ib718d5edc6b5e14bc3ea0592e0146468ff70b43e Signed-off-by: wym_libra <yimin.wang@huawei.com>
Diffstat (limited to 'yardstick/benchmark/scenarios/availability/attacker')
-rwxr-xr-xyardstick/benchmark/scenarios/availability/attacker/__init__.py0
-rw-r--r--yardstick/benchmark/scenarios/availability/attacker/attacker_conf.yaml9
-rw-r--r--yardstick/benchmark/scenarios/availability/attacker/attacker_process.py67
-rw-r--r--yardstick/benchmark/scenarios/availability/attacker/baseattacker.py47
-rwxr-xr-xyardstick/benchmark/scenarios/availability/attacker/scripts/check_service.bash18
-rwxr-xr-xyardstick/benchmark/scenarios/availability/attacker/scripts/start_service.bash18
-rwxr-xr-xyardstick/benchmark/scenarios/availability/attacker/scripts/stop_service.bash21
7 files changed, 180 insertions, 0 deletions
diff --git a/yardstick/benchmark/scenarios/availability/attacker/__init__.py b/yardstick/benchmark/scenarios/availability/attacker/__init__.py
new file mode 100755
index 000000000..e69de29bb
--- /dev/null
+++ b/yardstick/benchmark/scenarios/availability/attacker/__init__.py
diff --git a/yardstick/benchmark/scenarios/availability/attacker/attacker_conf.yaml b/yardstick/benchmark/scenarios/availability/attacker/attacker_conf.yaml
new file mode 100644
index 000000000..44f06038b
--- /dev/null
+++ b/yardstick/benchmark/scenarios/availability/attacker/attacker_conf.yaml
@@ -0,0 +1,9 @@
+---
+# sample config file for ha test
+#
+schema: "yardstick:task:0.1"
+
+kill-process:
+ inject_script: scripts/stop_service.bash
+ recovery_script: scripts/start_service.bash
+ check_script: scripts/check_service.bash
diff --git a/yardstick/benchmark/scenarios/availability/attacker/attacker_process.py b/yardstick/benchmark/scenarios/availability/attacker/attacker_process.py
new file mode 100644
index 000000000..5118ad628
--- /dev/null
+++ b/yardstick/benchmark/scenarios/availability/attacker/attacker_process.py
@@ -0,0 +1,67 @@
+##############################################################################
+# Copyright (c) 2015 Huawei Technologies Co.,Ltd. and others
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+import logging
+
+from baseattacker import BaseAttacker
+import yardstick.ssh as ssh
+
+LOG = logging.getLogger(__name__)
+
+
+class ProcessAttacker(BaseAttacker):
+
+ __attacker_type__ = 'kill-process'
+
+ def setup(self):
+ LOG.debug("config:%s context:%s" % (self._config, self._context))
+ host = self._context.get(self._config['host'], None)
+ ip = host.get("ip", None)
+ user = host.get("user", "root")
+ key_filename = host.get("key_filename", "~/.ssh/id_rsa")
+
+ self.connection = ssh.SSH(user, ip, key_filename=key_filename)
+ self.connection.wait(timeout=600)
+ LOG.debug("ssh host success!")
+
+ self.service_name = self._config['process_name']
+ self.fault_cfg = BaseAttacker.attacker_cfgs.get('kill-process')
+
+ self.check_script = self.get_script_fullpath(
+ self.fault_cfg['check_script'])
+ self.inject_script = self.get_script_fullpath(
+ self.fault_cfg['inject_script'])
+ self.recovery_script = self.get_script_fullpath(
+ self.fault_cfg['recovery_script'])
+
+ if self.check():
+ self.setup_done = True
+
+ def check(self):
+ exit_status, stdout, stderr = self.connection.execute(
+ "/bin/sh -s {0}".format(self.service_name),
+ stdin=open(self.check_script, "r"))
+
+ if stdout and "running" in stdout:
+ LOG.info("check the envrioment success!")
+ return True
+ else:
+ LOG.error(
+ "the host envrioment is error, stdout:%s, stderr:%s" %
+ (stdout, stderr))
+ return False
+
+ def inject_fault(self):
+ exit_status, stdout, stderr = self.connection.execute(
+ "/bin/sh -s {0}".format(self.service_name),
+ stdin=open(self.inject_script, "r"))
+
+ def recover(self):
+ exit_status, stdout, stderr = self.connection.execute(
+ "/bin/sh -s {0} ".format(self.service_name),
+ stdin=open(self.recovery_script, "r"))
diff --git a/yardstick/benchmark/scenarios/availability/attacker/baseattacker.py b/yardstick/benchmark/scenarios/availability/attacker/baseattacker.py
new file mode 100644
index 000000000..ddaf09969
--- /dev/null
+++ b/yardstick/benchmark/scenarios/availability/attacker/baseattacker.py
@@ -0,0 +1,47 @@
+##############################################################################
+# Copyright (c) 2015 Huawei Technologies Co.,Ltd. and others
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+import pkg_resources
+import yaml
+import logging
+import os
+
+import yardstick.common.utils as utils
+
+LOG = logging.getLogger(__name__)
+
+attacker_conf_path = pkg_resources.resource_filename(
+ "yardstick.benchmark.scenarios.availability.attacker",
+ "attacker_conf.yaml")
+
+
+class BaseAttacker(object):
+
+ attacker_cfgs = {}
+
+ def __init__(self, config, context):
+ if not BaseAttacker.attacker_cfgs:
+ with open(attacker_conf_path) as stream:
+ BaseAttacker.attacker_cfgs = yaml.load(stream)
+
+ self._config = config
+ self._context = context
+ self.setup_done = False
+
+ @staticmethod
+ def get_attacker_cls(attacker_cfg):
+ '''return attacker instance of specified type'''
+ attacker_type = attacker_cfg['fault_type']
+ for attacker_cls in utils.itersubclasses(BaseAttacker):
+ if attacker_type == attacker_cls.__attacker_type__:
+ return attacker_cls
+ raise RuntimeError("No such runner_type %s" % attacker_type)
+
+ def get_script_fullpath(self, path):
+ base_path = os.path.dirname(attacker_conf_path)
+ return os.path.join(base_path, path)
diff --git a/yardstick/benchmark/scenarios/availability/attacker/scripts/check_service.bash b/yardstick/benchmark/scenarios/availability/attacker/scripts/check_service.bash
new file mode 100755
index 000000000..cc898a859
--- /dev/null
+++ b/yardstick/benchmark/scenarios/availability/attacker/scripts/check_service.bash
@@ -0,0 +1,18 @@
+#!/bin/bash
+
+##############################################################################
+# Copyright (c) 2015 Huawei Technologies Co.,Ltd and others.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+
+# check the status of a service
+
+set -e
+
+service_name=$1
+
+service $service_name status
diff --git a/yardstick/benchmark/scenarios/availability/attacker/scripts/start_service.bash b/yardstick/benchmark/scenarios/availability/attacker/scripts/start_service.bash
new file mode 100755
index 000000000..c1bf8b7eb
--- /dev/null
+++ b/yardstick/benchmark/scenarios/availability/attacker/scripts/start_service.bash
@@ -0,0 +1,18 @@
+#!/bin/bash
+
+##############################################################################
+# Copyright (c) 2015 Huawei Technologies Co.,Ltd and others.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+
+# Start a service and check the service is started
+
+set -e
+
+service_name=$1
+
+service $service_name start
diff --git a/yardstick/benchmark/scenarios/availability/attacker/scripts/stop_service.bash b/yardstick/benchmark/scenarios/availability/attacker/scripts/stop_service.bash
new file mode 100755
index 000000000..a8901784e
--- /dev/null
+++ b/yardstick/benchmark/scenarios/availability/attacker/scripts/stop_service.bash
@@ -0,0 +1,21 @@
+#!/bin/bash
+
+##############################################################################
+# Copyright (c) 2015 Huawei Technologies Co.,Ltd and others.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+
+# Stop a service and check the service is stoped
+
+set -e
+
+service_name=$1
+
+service $service_name stop
+
+# TODO
+# check the service status